<?php

/********************************************************************************************************************************
*
*  Status update (/statusupfates.php)
*  Author: Krzysztof "Supryk" Supryczyński
*  Copyright: © 2013 - 2016 @ Krzysztof "Supryk" Supryczyński @ All rights reserved
*  
*  Website: 
*  Description: User status update like IP.Board.
*
********************************************************************************************************************************/
/********************************************************************************************************************************
*
* This file is part of "Status update" plugin for MyBB.
* Copyright © 2013 - 2016 @ Krzysztof "Supryk" Supryczyński @ All rights reserved
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
********************************************************************************************************************************/
 
define("IN_MYBB", "1"); 
define("THIS_SCRIPT", "statusupdate.php");

$templatelist = "statusupdate, statusupdate_script, ";
$templatelist .= "statusupdate_index, statusupdate_index_row, statusupdate_index_row_none, statusupdate_index_row_add_comment_form, statusupdate_index_row_show_comment, statusupdate_index_row_show_comment_row, ";
$templatelist .="statusupdate_usercp_delete, statusupdate_usercp_edit, statusupdate_usercp_link, ";
$templatelist .= "multipage,multipage_end,multipage_jump_page,multipage_nextpage,multipage_page,multipage_page_current,multipage_page_link_current,multipage_prevpage,multipage_start";

require "./global.php"; 

require_once MYBB_ROOT."inc/class_parser.php";
$parser = new postParser;

$lang->load("statusupdate");

if(!$db->num_rows($db->simple_select("settinggroups", "*", "name=\"statusupdate\"")))
{
	error($lang->statusupdate_not_installed);
}

if($mybb->usergroup['canviewstatusupdate'] != '1')
{
	error_no_permission();
}

$plugins->run_hooks("statusupdate_start");

if($mybb->input['action'] == "do_add_comment_statusupdate"  && $mybb->request_method == "post")
{
	if(!verify_post_check($mybb->get_input('my_post_key'), true))
	{
		error($lang->statusupdate_ivalid_post_key);
	}

	if($mybb->get_input('commenttext') == '')
	{
		error($lang->statusupdate_comment_empty);
	}
	
	if(strlen($mybb->get_input('commenttext')) > $mybb->settings['statusupdate_max_comment_symbols'])
	{
		error($lang->sprintf($lang->statusupdate_comment_too_long, $mybb->settings['statusupdate_max_comment_symbols']));
	}
		
	if($mybb->usergroup['canaddstatusupdatecomments'] != '1')
	{
		error($lang->statusupdate_no_permissions_to_add_comment);
	}
		
	if($mybb->get_input('sid', 1) == "0")
	{
		error($lang->statusupdate_ivalid_status_id);
	}
		
	$comment = array(
		"sid"			=> $mybb->get_input('sid', 1),
		"uid"				=> $mybb->get_input('uid', 1),
		"text"				=> $db->escape_string($mybb->get_input('commenttext')),
		"dateline"	=> TIME_NOW,
		"ipaddress" => $session->packedip,
	);
	$db->insert_query("statusupdatecomments", $comment);
	
	$status = array(
		"totalcomments" =>  $mybb->get_input('totalcomments', 1) + 1,
	);
	
	$db->update_query("statusupdate", $status, "sid='".$mybb->get_input('sid', 1)."'");
		
	redirect("index.php", $lang->statusupdate_comment_added);
}

if(!$mybb->input['action'])
{	
	if($mybb->settings['statusupdate_subpage_limit'] <= "0")
	{
		$mybb->settings['statusupdate_subpage_limit'] = "20";
	}
	
	$uidsearchsql = "";
	$sidsearchsql = "";
	
	If($mybb->get_input("uid", 1) != "0")
	{
		$uidsearchsql = " AND uid = '".$mybb->get_input("uid", 1)."'";
	}
	
	If($mybb->get_input("sid", 1) != "0")
	{
		$sidsearchsql = " AND sid = '".$mybb->get_input("sid", 1)."'";
	}
	
	$sids = "";
	$comma = '';
		
	$query = $db->query("
		SELECT *
		FROM ".TABLE_PREFIX."statusupdate
		WHERE 1=1{$uidsearchsql}{$sidsearchsql}");
	while($getsids = $db->fetch_array($query))
	{
		if(empty($sid))
		{
			$sid = $getsids['sid'];
		}

		$sids .= "$comma'{$getsids['sid']}'";
		$comma = ",";
	}
	
	if($sids)
	{
		$sids = "sc.sid IN($sids)";
	}
		
	$statuscount = $db->num_rows($query);
	$perpage = $mybb->settings['statusupdate_subpage_limit'];
	$page = $mybb->get_input('page', 1);
	if($page > 0)
	{
		$start = ($page-1) * $perpage;
		$pages = $statuscount / $perpage;
		$pages = ceil($pages);
			
		if($page > $pages || $page <= 0)
		{
			$start = 0;
			$page = 1;
		}
	}
	else
	{
		$start = 0;
		$page = 1;
	}
	$end = $start + $perpage;
	$lower = $start+1;
	$upper = $end;
		
	if($upper > $statuscount)
	{
		$upper = $statuscount;
	}
		
	If($mybb->get_input("uid", 1) != "0")
	{
		$uidsearchurl = "?uid=".$mybb->get_input("uid", 1)."";
	}
		
	$multipage = multipage($statuscount, $perpage, $page, "statusupdate.php{$uidsearchurl}");
		
	$bgcolor = alt_trow();
	$statusupdate_statuses = "";
	
	If($mybb->get_input("uid", 1) != "0")
	{
		$uidsearchsql = " AND s.uid = '".$mybb->get_input("uid", 1)."'";
	}
	
	If($mybb->get_input("sid", 1) != "0")
	{
		$sidsearchsql .= " AND s.sid = '".$mybb->get_input("sid", 1)."'";
	}
		
	$query = $db->query("
		SELECT 
		s.sid as statussid, s.uid as statusuid, s.text as statustext, s.dateline as statusdateline, s.lastedituid as statuslastedituid, s.lasteditdate as statuslasteditdate, s.totalcomments as statustotalcomments, s.ipaddress as statusipaddress,
		su.uid as statusuid, su.username as statususername, su.usergroup as statususergroup, su.displaygroup as statusdisplaygroup, su.avatar as statusavatar, su.avatardimensions as statusavatardimensions
		FROM ".TABLE_PREFIX."statusupdate s
		LEFT JOIN ".TABLE_PREFIX."users su ON (s.uid=su.uid)
		WHERE 1=1{$uidsearchsql}{$sidsearchsql}
		ORDER BY s.lasteditdate DESC
		LIMIT $start, $perpage");
		
	if($db->num_rows($query))
	{
		while($rowstatus = $db->fetch_array($query))
		{
			$tpl['statussid'] = $rowstatus['statussid'];
			$tpl['statususername'] = format_name($rowstatus['statususername'], $rowstatus['statususergroup'], $rowstatus['statusdisplaygroup']);
			$tpl['statusprofilelink'] = build_profile_link($tpl['statususername'], $rowstatus['statusuid']);
			$tpl['statusdate'] = my_date("relative", $rowstatus['statuslasteditdate']);
				
			$statususeravatar = format_avatar(htmlspecialchars_uni($rowstatus['statusavatar']));
				
			$parser_options = array(
				"allow_html" => 0,
				"allow_mycode" => 1,
				"allow_smilies" => 1,
				"allow_imgcode" => 0, 
				"allow_videocode" => 0, 
				"filter_badwords" => 1,
			);
			$tpl['statustext'] = $parser->parse_message($rowstatus['statustext'], $parser_options); 
				
			$tpl['statustotalcomments'] = my_number_format($rowstatus['statustotalcomments']);
				
			$showcomments = "";
			$commentcount = "";
				
			if($rowstatus['statustotalcomments'] > 0 && $mybb->usergroup['canviewstatusupdatecomments'] == '1')
			{
				$showcomments = "<span id=\"showcomment_".$tpl['statussid']."\" class=\"showcomment\">".$lang->statusupdate_showcomments."</span>";
				$commentcount = " <span id=\"commentcount_".$tpl['statussid']."\">(".$tpl['statustotalcomments'].")</span>";
				$tpl['rowcomments'] = "";
					
				static $comments;
				static $comments_check = false;
					
				if(!$comments_check)
				{	
					$querycomment = $db->query("
						SELECT 
						sc.cid as commentcid, sc.sid as commentsid, sc.uid as commentuid, sc.text as commenttext, sc.dateline as commentdateline, sc.ipaddress as commentipaddress,
						cu.uid as commentuid, cu.username as commentusername, cu.usergroup as commentusergroup, cu.displaygroup as commentdisplaygroup, cu.avatar as commentavatar, cu.avatardimensions as commentavatardimensions
						FROM ".TABLE_PREFIX."statusupdatecomments sc 
						LEFT JOIN ".TABLE_PREFIX."users cu ON (sc.uid=cu.uid)
						WHERE 1=1 AND {$sids}
						ORDER BY sc.dateline DESC");
					while($rowcomment = $db->fetch_array($querycomment))
					{
						$comments[$rowcomment['commentsid']][] = $rowcomment;
					}
					
					$comments_check = true;
				} 

				if(isset($comments[$tpl['statussid']]))
				{	
					foreach($comments[$tpl['statussid']] as $comment)
					{
						$tpl['commentusername'] = format_name($comment['commentusername'], $comment['commentusergroup'], $comment['commentdisplaygroup']);
						$tpl['commentprofilelink'] = build_profile_link($tpl['commentusername'], $comment['commentuid']);
						$tpl['commentdate'] = my_date('relative', $comment['commentdateline']);
							
						$commentuseravatar = format_avatar(htmlspecialchars_uni($comment['commentavatar']), $comment['commentavatardimensions']);

						$parser_options = array(
							"allow_html" => 0,
							"allow_mycode" => 1,
							"allow_smilies" => 1,
							"allow_imgcode" => 0, 
							"allow_videocode" => 0, 
							"filter_badwords" => 1,
						);
							
						$tpl['commenttext'] = $parser->parse_message($comment['commenttext'], $parser_options); 
						eval("\$tpl['rowcomments'] .= \"" . $templates->get("statusupdate_index_row_show_comment_row") . "\";");
					}
						
					eval("\$statusupdatecomment = \"".$templates->get("statusupdate_index_row_show_comment")."\";");
				}
			}
				
			$addcomments = "";
		
			if($mybb->usergroup['canaddstatusupdatecomments'] == '1')
			{
				$addcomments = "<span id=\"addcomments_".$tpl['statussid']."\" class=\"addcomment\">".$lang->statusupdate_addcomment."</span>";
				eval('$statusupdatecommentform = "'.$templates->get("statusupdate_index_row_add_comment_form").'";');
			}
					
			$br = "";
				
			if($showcomments || $addcomments)
			{
				$br = "<br />";
			}
					
			$sep = "";
					
			if($showcomments && $addcomments)
			{
				$sep = "<span> | </span>";
			}
			
			$statusupdate_edit = "";
			$statusupdate_delete = "";
			/*
			if(is_moderator("0", "caneditownstatusupdate"))
			{						
				$edit_url = "usercp.php?action=statusupdate&edit=".$rowstatus['statussid'];
						
				eval('$statusupdate_edit = "'.$templates->get("statusupdate_usercp_edit").'";');
			}
			
			if(is_moderator("0", "candeleteownstatusupdate"))
			{						
				$delete_url = "usercp.php?action=statusupdate&delete=".$rowstatus['statussid'];
						
				eval('$statusupdate_delete = "'.$templates->get("statusupdate_usercp_delete").'";');
			}
			*/
			if($mybb->user['uid'] == $rowstatus['statusuid'])
			{							
				if($mybb->usergroup['caneditownstatusupdate'] == '1')
				{						
					$edit_url = "usercp.php?action=statusupdate&edit=".$rowstatus['statussid']."&goedit=1";
						
					eval('$statusupdate_edit = "'.$templates->get("statusupdate_usercp_edit").'";');
				}
				
				if($mybb->usergroup['candeleteownstatusupdate'] == '1')
				{						
					$delete_url = "usercp.php?action=statusupdate&delete=".$rowstatus['statussid']."&godelete=1";
						
					eval('$statusupdate_delete = "'.$templates->get("statusupdate_usercp_delete").'";');
				}
			}
			
			eval('$statusupdate_link = "'.$templates->get("statusupdate_usercp_link").'";');

			eval("\$tpl['row'] .= \"" . $templates->get("statusupdate_index_row") . "\";");
			$bgcolor = alt_trow();
		}
	}
	else
	{
		eval("\$tpl['row'] = \"" . $templates->get("statusupdate_index_row_none") . "\";");
	}
	
	if($mybb->usergroup['canaddstatusupdate'] == '1') 
	{
		$set = "<span> <a href=\"".$mybb->settings['bburl']."/usercp.php?action=statusupdate\">".$lang->statusupdate_set."</a></span>";
	}
		
	eval("\$statusupdate_statusupdate = \"".$templates->get("statusupdate_index")."\";");
		
		
	add_breadcrumb($lang->statusupdate_statusupdate);
	eval('$statusupdate_script = "'.$templates->get("statusupdate_script").'";');
		eval('$statusupdate = "'.$templates->get("statusupdate").'";');
	output_page($statusupdate);
}